    001/*
    002    Licensed to the Apache Software Foundation (ASF) under one
    003    or more contributor license agreements.  See the NOTICE file
    004    distributed with this work for additional information
    005    regarding copyright ownership.  The ASF licenses this file
    006    to you under the Apache License, Version 2.0 (the
    007    "License"); you may not use this file except in compliance
    008    with the License.  You may obtain a copy of the License at
    009
    010       http://www.apache.org/licenses/LICENSE-2.0
    011
    012    Unless required by applicable law or agreed to in writing,
    013    software distributed under the License is distributed on an
    014    "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    015    KIND, either express or implied.  See the License for the
    016    specific language governing permissions and limitations
    017    under the License.
    018 */
    019package org.apache.wiki.attachment;
    020
    021import org.apache.wiki.api.core.Attachment;
    022import org.apache.wiki.api.core.Context;
    023import org.apache.wiki.api.exceptions.ProviderException;
    024
    025import java.io.IOException;
    026import java.io.InputStream;
    027
    028
    029/**
    030 *  Provides the data for an attachment.  Please note that there will be a strong reference retained for the provider for each Attachment
    031 *  it provides, so do try to keep the object light.  Also, reuse objects if possible.
    032 *  <p>
    033 *  The Provider needs to be thread-safe.
    034 *
    035 *  @since  2.5.34
    036 */
    037public interface DynamicAttachmentProvider {
    038
    039    /**
    040     *  Returns a stream of data for this attachment.  The stream will be closed by AttachmentServlet.
    041     *
    042     *  @param context A Wiki Context
    043     *  @param att The Attachment for which the data should be received.
    044     *  @return InputStream for the data.
    045     *  @throws ProviderException If something goes wrong internally
    046     *  @throws IOException If something goes wrong when reading the data
    047     */
    048    InputStream getAttachmentData( Context context, Attachment att ) throws ProviderException, IOException;
    049
    050}